// Recursie cu memoizare - 35 puncte
// Constantin Galatan
#include <fstream>
#include <vector>
#include <iomanip>
#include <cmath>
#include <iostream>
#include <cstring>
#include <limits>
#include <cassert>
using namespace std;

#define DIM1 20
#define DIM2 1 << 10
#define INF  16000      //0x3f3f3f3f

ifstream fin("cmin.in");
ofstream fout("cmin.out");

short a[DIM1][DIM1];
short aa[DIM1][DIM1];
short bb[DIM1][DIM1];
pair<short, short> cc[DIM1][DIM1];   // cc[j][k].first == costul minim ca sa am k jetoane deasupra, pe col j)
short c[DIM1][DIM2][DIM1*DIM1/2];
int col[DIM1];
int up[DIM1];   // up[j] - cate deasupra pe col j
int n; // dim matricei (n trebuie sa fie par)
int N; // nr total de jetoane

void Read();
short Cmin(int j, short mask, short pus);  // k - poz in sirul x[],
void PreCompute();

int main()
{
	Read();
	memset(c, -1, sizeof(c));

	PreCompute();
	fout << Cmin(1, 0, 0) << '\n';
	fout.close();
	return 0;
}

void PreCompute()
{
	// initializare
	for ( int j = 1; j <= n; ++j )		// coloana
		for ( int k = 0; k <= n / 2; ++k ) // jetoane
		{
			if ( k == up[j] )
			{
				cc[j][k].first = 0;

			}
			else
				cc[j][k].first = INF;
		}

	// urc jetoane sus pornind de la starea initiala
	int p1, p2, k; bool ok;
	for ( int j = 1; j <= n; ++j ) // coloana
	{
		ok = true; k = 0;
		while ( ok )
		{
			for ( p1 = n / 2 + 1; p1 <= n; ++p1 )
				if ( aa[p1][j] )  // jeton de jos
					break;
			for ( p2 = n / 2; p2 >= 1; --p2 )
				if ( aa[p2][j] == 0 ) // celula libera de sus
					break;
			if ( p1 <= n && p2 >= 1 ) // pot muta jetonul
			{
				++k;
				assert(up[j] + k <= n);
				cc[j][up[j] + k].first = cc[j][up[j] + k - 1].first + p1 - p2;   // costul mutarii
				cc[j][up[j] + k].second |= (1 << (p2-1));
				cc[j][up[j] + k].second &= ~(1 << (p1-1));

				aa[p1][j] = 0, aa[p2][j] = 1;  // modific matricea caracteristica
				ok = true;
			}
			if ( p1 > n || p2 < 1 ) // n-am gasit loc sau n-am gasit jeton dedesupt
				ok = false;
		}
	}

	// cobor jetoane  pornind de la starea initiala
	for ( int j = 1; j <= n; ++j ) // coloana
	{
		ok = true; k = 0;
		while ( ok )
		{
			for ( p1 = n / 2; p1 >= 1;  --p1 )
				if ( bb[p1][j] )  // jeton de sus
					break;
			for ( p2 = n / 2 + 1; p2 <= n; ++p2 )
				if ( bb[p2][j] == 0 ) // celula libera de jos
					break;
			if ( p1 >= 1 && p2 <= n ) // pot muta jetonul
			{
				++k;
				assert(up[j] - k >= 0);
				cc[j][up[j] - k].first = cc[j][up[j] - k + 1].first + p2 - p1;   // costul mutarii
				cc[j][up[j] - k].second |= (1 << (p2-1));
				cc[j][up[j] - k].second &= ~(1 << (p1-1));

				bb[p1][j] = 0, bb[p2][j] = 1;  // modific matricea caracteristica
				ok = true;
			}
			if ( p1 < 1 || p2 > n ) // n-am gasit loc jos sau n-am gasit jeton sus
				ok = false;
		}
	}
}

short Cmin(int j, short mask, short pus)
{
	short& ret = c[j][mask][pus];
//	assert(ret < numeric_limits<short>::max());
//	assert(ret  > numeric_limits<short>::min());
 	if ( ret == -1 )  ret = INF;
	if ( ret != INF ) return ret;

	if ( j == n + 1 )
	{
		if ( N % 2 == 0 )
		{
			if ( pus == N / 2  )
				return ret = 0;
		}
		else
			if ( pus == N / 2 || pus == N / 2 + 1)
				return ret = 0;
		return ret = INF;
	}

	if ( pus > N / 2 + 1 )
		return ret = INF;

	if ( pus == N / 2 && col[j] > n / 2  + 1)
		return ret = INF;

	for ( int k = 0; k <= n / 2; ++k )
	{
		if ( cc[j][k].first == INF ) continue;
		int x = Cmin(j + 1, cc[j][k].second, pus + k );
	//	assert(x < numeric_limits<short>::max());
		int y = cc[j][k].first + x;
	//	assert( y < numeric_limits<short>::max());
		ret = min(ret, (short)y );
	}

	return ret;
}

void Read()
{
	fin >> n;
	for ( int i = 1; i <= n; ++i )
		for ( int j = 1; j <= n; ++j )
		{
			fin >> a[i][j];
			aa[i][j] = bb[i][j] = a[i][j];
			col[j] += a[i][j];
			if ( a[i][j] && i <= n / 2)
				up[j]++;
			N += a[i][j];
		}
	fin.close();
}


