// Rec + memo
// Constantin Galatan
#include <fstream>
#include <vector>
#include <iomanip>
#include <iostream>
#include <cstring>
#include <cassert>
#include <limits>
#include <iomanip>
using namespace std;

typedef short US;
#define DIM1 100
#define INF  16000 //0x3f3f3f3f
#define BAD 15000  // 0x3f3f3f00
ifstream fin("cmin.in");
ofstream fout("cmin.out");

US a[DIM1][DIM1];             // a, b, configuratia initiala
US b[DIM1][DIM1];
US cc[DIM1][DIM1+1];       // cc[j][k] == costul minim ca sa plasez k jetoane pe col j, deasupra liniei n / 2)
US c[DIM1+1][DIM1*DIM1];  // costul minim pentru coloanele [j..n-1] cu p jetoane plasate deja
                              // (deasupra liniei n / 2 ) pana la col j - 1, daca plasez k jetoane pe col j
US col[DIM1];
US up[DIM1];   // up[j] - cate jetoane pe col j (pe liniiile 0... n/2-1
US n; // dim matricei (n trebuie sa fie par)
US N; // nr total de jetoane

void Read();
void PreCompute();   // calculez matricea cc[][]
void Debug(US a[DIM1][DIM1*DIM1], int i, int k);
void Debug2(US a[DIM1][DIM1], int m, int n);
US Cmin(int j, int p, int k);

int main()
{
	Read();
	PreCompute();
//	Debug(cc, n / 2, n / 2 + 1);
//	fout << '\n' ;
	memset(c, -1, sizeof(c));
	fout << Cmin(0, 0, 0) << '\n';

	fout.close();
	return 0;
}

// Cmin - costul minim pentru coloanele [j..n-1] cu p jetoane
// plasate (deasupra mijlocului) pana la col j - 1 si cu k jetoane pe col j
US Cmin(int j, int p, int k)
{
    US &ret = c[j][p];
    if ( ret == -1 )  ret = INF;
	if ( ret != INF ) return ret; // daca e BAD, nu mai explorez

	if ( j == n )
	{
	    if ( p == N / 2 ) return 0;
	    if ( N & 1 && p == N / 2 + 1 ) return 0;// impar
        return BAD;
    }
    if ( k > col[j] || k > n / 2 ) return  ret = INF;
	if ( p > N / 2 + 1) return  ret = BAD;
	if ( k <= n / 2 )
	{
		ret = min(ret, Cmin(j, p, k + 1));
		if ( ret == BAD ) return ret;

        if ( cc[j][k] != INF )
        {
            US x = Cmin(j + 1, p + k, 0);
            if ( x != BAD )
            {
                x += cc[j][k];
                ret = min(ret, x);
            }
        }
	}
	return ret;
}

void PreCompute()
{
	// initializare cc[][]
	int K = max(n / 2, N / 2 + 1);
	for ( int j = 0; j < n; ++j )		// coloana
		for ( int k = 0; k <= K; ++k ) // jetoane
		{
			if ( k == up[j] )
				cc[j][k] = 0;
			else
				cc[j][k] = INF;
		}

	// urc jetoane sus pornind de la starea initiala
	int p1, p2, k; bool ok;
	for ( int j = 0; j < n; ++j ) // coloana
	{
		ok = true; k = 0;
		while ( ok )
		{
			for ( p1 = n / 2; p1 < n; ++p1 )
				if ( a[p1][j] )  // jeton de jos
					break;
			for ( p2 = n / 2 - 1; p2 >= 0; --p2 )
				if ( a[p2][j] == 0 ) // celula libera de sus
					break;
			if ( p1 < n && p2 >= 0 ) // pot muta jetonul
			{
				++k;
				cc[j][up[j] + k] = cc[j][up[j] + k - 1] + p1 - p2;   // costul mutarii
				a[p1][j] = 0, a[p2][j] = 1;  // modific matricea caracteristica
				ok = true;
			}
			if ( p1 >= n || p2 < 0 ) // n-am gasit loc sau n-am gasit jeton dedesupt
				ok = false;
		}
	}

	// cobor jetoane  pornind de la starea initiala
	for ( int j = 0; j < n; ++j ) // coloana
	{
		ok = true; k = 0;
		while ( ok )
		{
			for ( p1 = n / 2 - 1; p1 >= 0;  --p1 )
				if ( b[p1][j] )  // jeton de sus
					break;
			for ( p2 = n / 2; p2 < n; ++p2 )
				if ( b[p2][j] == 0 ) // celula libera de jos
					break;
			if ( p1 >= 0 && p2 < n ) // pot muta jetonul
			{
				++k;
			//	assert(up[j] - k >= 0);

				cc[j][up[j] - k] = cc[j][up[j] - k + 1] + p2 - p1;   // costul mutarii
				b[p1][j] = 0, b[p2][j] = 1;  // modific matricea caracteristica
				ok = true;
			}
			if ( p1 < 0 || p2 >= n ) // n-am gasit loc jos sau n-am gasit jeton sus
				ok = false;
		}
	}
}

void Read()
{
	int x;
	fin >> n;
	for ( int i = 0; i < n; ++i )
		for ( int j = 0; j < n; ++j )
		{
			fin >> x;
			b[i][j] = a[i][j] = x;
			col[j] += x;
			if ( x && i < n / 2)
				up[j]++;
			N += x;
		}
	fin.close();
}

void Debug(US a[DIM1][DIM1*DIM1], int m, int n)
{
	for ( int i = 0; i <= m; ++i )
	{
		for ( int k = 0; k <= n; ++k )
			if ( a[i][k] == INF )
				fout << setw(4) << "INF";
			else
				fout << setw(4) << a[i][k];
		fout << '\n';
	}
}

void Debug2(US a[DIM1][DIM1], int m, int n)
{
	for ( int i = 0; i <= m; ++i )
	{
		for ( int k = 0; k <= n; ++k )
			if ( a[i][k] == INF )
				fout << setw(4) << "INF";
			else
				fout << setw(4) << a[i][k];
		fout << '\n';
	}
}
